"use strict";

var __awaiter = undefined && undefined.__awaiter || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) {
            try {
                step(generator.next(value));
            } catch (e) {
                reject(e);
            }
        }
        function rejected(value) {
            try {
                step(generator["throw"](value));
            } catch (e) {
                reject(e);
            }
        }
        function step(result) {
            result.done ? resolve(result.value) : new P(function (resolve) {
                resolve(result.value);
            }).then(fulfilled, rejected);
        }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const fs_1 = require("fs");
const lsr_1 = require("lsr");
const yeoman_test_1 = require("yeoman-test");
test('moped-generator', () => __awaiter(undefined, void 0, void 0, function* () {
    // The object returned acts like a promise, so return it to wait until the process is done
    const dirname = yield yeoman_test_1.run(require.resolve('../../../generators/app'))
    // .withOptions({ foo: 'bar' })    // Mock options passed in
    // .withPrompts({ coffee: false }); // Mock the prompt answers
    .withArguments(['name-x']); // Mock the arguments
    expect(lsr_1.lsrSync(dirname).map(entry => {
        if (entry.isDirectory()) {
            return 'DIRECTORY: ' + entry.path;
        } else {
            return 'FILE: ' + entry.path + '\n\n' + fs_1.readFileSync(entry.fullPath, 'utf8') + '\n';
        }
    }).join('\n')).toMatchSnapshot();
}));
//# sourceMappingURL=index.test.js.map